Merge remote-tracking branch 'alexis/lib-jvm'
[nit.git] / tests / tests.sh
1 #!/bin/bash
2 # This file is part of NIT ( http://www.nitlanguage.org ).
3 #
4 # Copyright 2004-2008 Jean Privat <jean@pryen.org>
5 #
6 # Licensed under the Apache License, Version 2.0 (the "License");
7 # you may not use this file except in compliance with the License.
8 # You may obtain a copy of the License at
9 #
10 # http://www.apache.org/licenses/LICENSE-2.0
11 #
12 # Unless required by applicable law or agreed to in writing, software
13 # distributed under the License is distributed on an "AS IS" BASIS,
14 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
15 # See the License for the specific language governing permissions and
16 # limitations under the License.
17
18 # This shell script compile, run and verify Nit program files
19
20 # Set lang do default to avoid failed tests because of locale
21 export LANG=C
22 export NIT_TESTING=true
23
24 unset NIT_DIR
25
26 # Get the first Java lib available
27 shopt -s nullglob
28 paths=`echo /usr/lib/jvm/*/`
29 paths=($paths)
30 JAVA_HOME=${paths[0]}
31
32 paths=`echo $JAVA_HOME/jre/lib/*/{client,server}/`
33 paths=($paths)
34 JNI_LIB_PATH=${paths[0]}
35 shopt -u nullglob
36
37 usage()
38 {
39 e=`basename "$0"`
40 cat<<END
41 Usage: $e [options] modulenames
42 -o option Pass option to the engine
43 -v Verbose (show tests steps)
44 -h This help
45 --tap Produce TAP output
46 --engine Use a specific engine (default=nitg)
47 --noskip Do not skip a test even if the .skip file matches
48 --[no]soso Force enable (or disable) SOSO
49 END
50 }
51
52 # $1 is the pattern of the test
53 # $2 is the file to compare to
54 # the result is:
55 # 0: if the file to compare to do not exists
56 # 1: if the file match
57 # 2: if the file match with soso
58 # 3: if the file do not match
59 function compare_to_result()
60 {
61 local pattern="$1"
62 local sav="$2"
63 if [ ! -r "$sav" ]; then return 0; fi
64 diff -u "$sav" "out/$pattern.res" > "out/$pattern.diff.sav.log"
65 if [ "$?" == 0 ]; then
66 return 1
67 fi
68 [ -z "$soso" ] && return 3
69 sed '/[Ww]arning/d;/[Ee]rror/d' "out/$pattern.res" > "out/$pattern.res2"
70 sed '/[Ww]arning/d;/[Ee]rror/d' "$sav" > "out/$pattern.sav2"
71 grep '[Ee]rror' "out/$pattern.res" >/dev/null && echo "Error" >> "out/$pattern.res2"
72 grep '[Ee]rror' "$sav" >/dev/null && echo "Error" >> "out/$pattern.sav2"
73 diff -u "out/$pattern.sav2" "out/$pattern.res2" > "out/$pattern.diff.sav.log"
74 if [ "$?" == 0 ]; then
75 return 2
76 else
77 return 3
78 fi
79 }
80
81 # As argument: the pattern used for the file
82 function process_result()
83 {
84 ((tapcount=tapcount+1))
85 # Result
86 pattern=$1
87 description=$2
88 pack=$3
89 SAV=""
90 NSAV=""
91 FIXME=""
92 NFIXME=""
93 SOSO=""
94 NSOSO=""
95 SOSOF=""
96 NSOSOF=""
97 OLD=""
98 LIST=""
99 FIRST=""
100 echo >>$xml "<testcase classname='$pack' name='$description'>"
101 #for sav in "sav/$engine/fixme/$pattern.res" "sav/$engine/$pattern.res" "sav/fixme/$pattern.res" "sav/$pattern.res" "sav/$pattern.sav"; do
102 for savdir in $savdirs; do
103 sav=$savdir/$pattern.res
104 compare_to_result "$pattern" "$sav"
105
106 case "$? $sav" in
107 0*)
108 continue;; # no file
109 1*/fixme/*)
110 OLD="$LIST"
111 FIXME="$sav"
112 ;;
113 1*)
114 OLD="$LIST"
115 SAV="$sav"
116 ;;
117 2*/fixme/*)
118 SOSOF="$sav" ;;
119 2*)
120 SOSO="$sav" ;;
121 3*/fixme/*)
122 if [ -z "$FIRST" ]; then
123 NFIXME="$sav"
124 FIRST="$sav"
125 fi
126 ;;
127 3*)
128 if [ -z "$FIRST" ]; then
129 NSAV="$sav"
130 FIRST="$sav"
131 fi
132 ;;
133 esac
134 LIST="$LIST $sav"
135 done
136 OLD=`echo "$OLD" | sed -e 's/ */ /g' -e 's/^ //' -e 's/ $//'`
137 grep 'NOT YET IMPLEMENTED' "out/$pattern.res" >/dev/null
138 NYI="$?"
139 if [ -n "$SAV" ]; then
140 if [ -n "$tap" ]; then
141 echo "ok - $description"
142 elif [ -n "$OLD" ]; then
143 echo "[*ok*] out/$pattern.res $SAV - but $OLD remains!"
144 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
145 remains="$remains $OLD"
146 else
147 echo "[ok] out/$pattern.res $SAV"
148 fi
149 ok="$ok $pattern"
150 elif [ -n "$FIXME" ]; then
151 if [ -n "$tap" ]; then
152 echo "not ok - $description # TODO expected failure"
153 elif [ -n "$OLD" ]; then
154 echo "[*fixme*] out/$pattern.res $FIXME - but $OLD remains!"
155 echo >>$xml "<error message='ok out/$pattern.res - but $OLD remains'/>"
156 remains="$remains $OLD"
157 else
158 echo "[fixme] out/$pattern.res $FIXME"
159 echo >>$xml "<skipped/>"
160 fi
161 todos="$todos $pattern"
162 elif [ -n "$SOSO" ]; then
163 if [ -n "$tap" ]; then
164 echo "ok - $description # SOSO"
165 else
166 echo "[soso] out/$pattern.res $SOSO"
167 fi
168 ok="$ok $pattern"
169 elif [ "x$NYI" = "x0" ]; then
170 if [ -n "$tap" ]; then
171 echo "not ok - $description # TODO not yet implemented"
172 else
173 echo "[todo] out/$pattern.res -> not yet implemented"
174 echo >>$xml "<skipped/>"
175 fi
176 todos="$todos $pattern"
177 elif [ -n "$SOSOF" ]; then
178 if [ -n "$tap" ]; then
179 echo "not ok - $description # TODO SOSO expected failure"
180 else
181 echo "[fixme soso] out/$pattern.res $SOSOF"
182 echo >>$xml "<skipped/>"
183 fi
184 todos="$todos $pattern"
185 elif [ -n "$NSAV" ]; then
186 if [ -n "$tap" ]; then
187 echo "not ok - $description"
188 else
189 echo "[======= fail out/$pattern.res $NSAV =======]"
190 fi
191 echo >>$xml "<error message='fail out/$pattern.res $NSAV'/>"
192 echo >>$xml "<system-out><![CDATA["
193 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
194 echo >>$xml "]]></system-out>"
195 nok="$nok $pattern"
196 echo "$ii" >> "$ERRLIST"
197 elif [ -n "$NFIXME" ]; then
198 if [ -n "$tap" ]; then
199 echo "not ok - $description"
200 else
201 echo "[======= changed out/$pattern.res $NFIXME ======]"
202 fi
203 echo >>$xml "<error message='changed out/$pattern.res $NFIXME'/>"
204 echo >>$xml "<system-out><![CDATA["
205 cat -v out/$pattern.diff.sav.log | head >>$xml -n 50
206 echo >>$xml "]]></system-out>"
207 nok="$nok $pattern"
208 echo "$ii" >> "$ERRLIST"
209 else
210 if [ -n "$tap" ]; then
211 echo "ok - $description # skip no sav"
212 else
213 echo "[=== no sav ===] out/$pattern.res"
214 fi
215 echo >>$xml "<skipped/>"
216 echo >>$xml "<system-out><![CDATA["
217 cat -v >>$xml out/$pattern.res
218 echo >>$xml "]]></system-out>"
219 nos="$nos $pattern"
220 fi
221 if test -s out/$pattern.cmp.err; then
222 echo >>$xml "<system-err><![CDATA["
223 cat -v >>$xml out/$pattern.cmp.err
224 echo >>$xml "]]></system-err>"
225 fi
226 echo >>$xml "</testcase>"
227 }
228
229 need_skip()
230 {
231 test "$noskip" = true && return 1
232 if echo "$1" | grep -f "$engine.skip" >/dev/null 2>&1; then
233 ((tapcount=tapcount+1))
234 if [ -n "$tap" ]; then
235 echo "ok - $2 # skip"
236 else
237 echo "=> $2: [skip]"
238 fi
239 echo >>$xml "<testcase classname='$3' name='$2'><skipped/></testcase>"
240 return 0
241 fi
242 return 1
243 }
244
245 find_nitc()
246 {
247 ((tapcount=tapcount+1))
248 name="$enginebinname"
249 recent=`ls -t ../src/$name ../src/$name_[0-9] ../bin/$name ../c_src/$name 2>/dev/null | head -1`
250 if [[ "x$recent" == "x" ]]; then
251 if [ -n "$tap" ]; then
252 echo "not ok - find binary for $engine"
253 echo "Bail out! Could not find binary for engine $engine, aborting"
254 else
255 echo "Could not find binary for engine $engine, aborting"
256 fi
257 exit 1
258 fi
259 if [ -n "$tap" ]; then
260 echo "ok - find binary for $engine: $recent $OPT"
261 else
262 echo "Find binary for engine $engine: $recent $OPT"
263 fi
264 NITC=$recent
265 }
266
267 verbose=false
268 stop=false
269 tapcount=0
270 engine=nitg
271 noskip=
272 while [ $stop = false ]; do
273 case $1 in
274 -o) OPT="$OPT $2"; shift; shift;;
275 -v) verbose=true; shift;;
276 -h) usage; exit;;
277 --tap) tap=true; shift;;
278 --engine) engine="$2"; shift; shift;;
279 --noskip) noskip=true; shift;;
280 --soso) soso=true; shift;;
281 --nososo) nososo=true; shift;;
282 *) stop=true
283 esac
284 done
285 enginebinname=$engine
286 case $engine in
287 nitg)
288 engine=nitg-s;
289 enginebinname=nitg;
290 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
291 OPT="--separate $OPT"
292 ;;
293 nitg-s)
294 enginebinname=nitg;
295 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
296 OPT="--separate $OPT"
297 ;;
298 nitg-e)
299 enginebinname=nitg;
300 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
301 OPT="--erasure $OPT"
302 ;;
303 nitg-g)
304 enginebinname=nitg;
305 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
306 OPT="--global $OPT"
307 ;;
308 nit)
309 engine=niti
310 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
311 ;;
312 niti)
313 enginebinname=nit
314 savdirs="sav/$engine/fixme/ sav/$engine/ sav/fixme/ sav/"
315 ;;
316 nitc)
317 echo "disabled engine $engine"
318 exit 0
319 ;;
320 *)
321 echo "unknown engine $engine"
322 exit 1
323 ;;
324 esac
325
326 # The default nitc compiler
327 [ -z "$NITC" ] && find_nitc
328
329 # Set NIT_DIR if needed
330 [ -z "$NIT_DIR" ] && export NIT_DIR=..
331
332 if sh -c "timelimit echo" 1>/dev/null 2>&1; then
333 TIMEOUT="timelimit -t 600"
334 elif sh -c "timeout 1 echo" 1>/dev/null 2>&1; then
335 TIMEOUT="timeout 600s"
336 else
337 echo "No timelimit or timeout command detected. Tests may hang :("
338 fi
339
340 # Mark to distinguish files among tests
341 # MARK=
342
343 # File where error tests are outputed
344 # Old ERRLIST is backuped
345 ERRLIST=${ERRLIST:-errlist}
346 ERRLIST_TARGET=$ERRLIST
347
348 if [ $# = 0 ]; then
349 usage;
350 exit
351 fi
352
353 # Initiate new ERRLIST
354 if [ "x$ERRLIST" = "x" ]; then
355 ERRLIST=/dev=null
356 else
357 ERRLIST=$ERRLIST.tmp
358 > "$ERRLIST"
359 fi
360
361 ok=""
362 nok=""
363 todos=""
364 xml="tests-$engine.xml"
365 echo >$xml "<testsuites><testsuite>"
366
367 # CLEAN the out directory
368 rm -rf out/ 2>/dev/null
369 mkdir out 2>/dev/null
370
371 for ii in "$@"; do
372 if [ ! -f $ii ]; then
373 echo "File '$ii' does not exist."
374 continue
375 fi
376 f=`basename "$ii" .nit`
377
378 pack=`echo $ii | perl -p -e 's|^../([^/]*)/([a-zA-Z_]*).*|\1.\2| || s|^([a-zA-Z]*)[^_]*_([a-zA-Z]*).*|\1.\2| || s|\W*([a-zA-Z_]*).*|\1|'`
379
380 # Sould we skip the file for this engine?
381 need_skip $f $f $pack && continue
382
383 tmp=${ii/../AA}
384 if [ "x$tmp" = "x$ii" ]; then
385 includes="-I . -I ../lib/standard -I ../lib/standard/collection -I alt"
386 else
387 includes="-I alt"
388 fi
389
390 for i in "$ii" `./alterner.pl --start '#' --altsep '_' $ii`; do
391 bf=`basename $i .nit`
392 ff="out/$bf"
393
394 # Sould we skip the alternative for this engine?
395 need_skip $bf $bf $pack && continue
396
397 test -z "$tap" && echo -n "=> $bf: "
398
399 if [ -f "$f.inputs" ]; then
400 inputs="$f.inputs"
401 else
402 inputs=/dev/null
403 fi
404
405 if [ "$engine" = "niti" ]; then
406 cat > "./$ff.bin" <<END
407 exec $NITC --no-color $OPT "$i" $includes -- "\$@"
408 END
409 chmod +x "./$ff.bin"
410 > "$ff.cmp.err"
411 > "$ff.compile.log"
412 ERR=0
413 else
414 # Compile
415 if [ "x$verbose" = "xtrue" ]; then
416 echo ""
417 echo $NITC --no-color $OPT -o "$ff.bin" "$i" "$includes"
418 fi
419 NIT_NO_STACK=1 JNI_LIB_PATH=$JNI_LIB_PATH JAVA_HOME=$JAVA_HOME \
420 $TIMEOUT $NITC --no-color $OPT -o "$ff.bin" "$i" $includes 2> "$ff.cmp.err" > "$ff.compile.log"
421 ERR=$?
422 if [ "x$verbose" = "xtrue" ]; then
423 cat "$ff.compile.log"
424 cat >&2 "$ff.cmp.err"
425 fi
426 fi
427 if [ "$ERR" != 0 ]; then
428 test -z "$tap" && echo -n "! "
429 cat "$ff.compile.log" "$ff.cmp.err" > "$ff.res"
430 process_result $bf $bf $pack
431 elif [ -x "./$ff.bin" ]; then
432 test -z "$tap" && echo -n ". "
433 # Execute
434 args=""
435 if [ "x$verbose" = "xtrue" ]; then
436 echo ""
437 echo "NIT_NO_STACK=1 ./$ff.bin" $args
438 fi
439 NIT_NO_STACK=1 LD_LIBRARY_PATH=$JNI_LIB_PATH \
440 $TIMEOUT "./$ff.bin" $args < "$inputs" > "$ff.res" 2>"$ff.err"
441 if [ "x$verbose" = "xtrue" ]; then
442 cat "$ff.res"
443 cat >&2 "$ff.err"
444 fi
445 if [ -f "$ff.write" ]; then
446 cat "$ff.write" >> "$ff.res"
447 elif [ -d "$ff.write" ]; then
448 LANG=C /bin/ls -F $ff.write >> "$ff.res"
449 fi
450 cp "$ff.res" "$ff.res2"
451 cat "$ff.cmp.err" "$ff.err" "$ff.res2" > "$ff.res"
452 process_result $bf $bf $pack
453
454 if [ -f "$f.args" ]; then
455 fargs=$f.args
456 cptr=0
457 while read line; do
458 ((cptr=cptr+1))
459 args="$line"
460 bff=$bf"_args"$cptr
461 fff=$ff"_args"$cptr
462 name="$bf args $cptr"
463
464 # Sould we skip the input for this engine?
465 need_skip $bff " $name" $pack && continue
466
467 # use a specific inputs file, if required
468 if [ -f "$bff.inputs" ]; then
469 ffinputs="$bff.inputs"
470 else
471 ffinputs=$inputs
472 fi
473
474 rm -rf "$fff.res" "$fff.err" "$fff.write" 2> /dev/null
475 if [ "x$verbose" = "xtrue" ]; then
476 echo ""
477 echo "NIT_NO_STACK=1 ./$ff.bin" $args
478 fi
479 test -z "$tap" && echo -n "==> $name "
480 echo "./$ff.bin $args" > "./$fff.bin"
481 chmod +x "./$fff.bin"
482 WRITE="$fff.write" sh -c "NIT_NO_STACK=1 $TIMEOUT ./$fff.bin < $ffinputs > $fff.res 2>$fff.err"
483 if [ "x$verbose" = "xtrue" ]; then
484 cat "$fff.res"
485 cat >&2 "$fff.err"
486 fi
487 if [ -f "$fff.write" ]; then
488 cat "$fff.write" >> "$fff.res"
489 elif [ -d "$fff.write" ]; then
490 LANG=C /bin/ls -F $fff.write >> "$fff.res"
491 fi
492 if [ -s "$fff.err" ]; then
493 cp "$fff.res" "$fff.res2"
494 cat "$fff.err" "$fff.res2" > "$fff.res"
495 fi
496 process_result $bff " $name" $pack
497 done < $fargs
498 fi
499 elif [ -f "./$ff.bin" ]; then
500 echo "Not executable (platform?)" > "$ff.res"
501 process_result $bf "$bf" $pack
502 else
503 test -z "$tap" && echo -n "! "
504 cat "$ff.cmp.err" > "$ff.res"
505 echo "Compilation error" > "$ff.res"
506 process_result $bf "$bf" $pack
507 fi
508 done
509 done
510
511 if [ -n "$tap" ]; then
512 echo "1..$tapcount"
513 echo "# ok:" `echo $ok | wc -w`
514 echo "# not ok:" `echo $nok | wc -w`
515 echo "# no sav:" `echo $nos | wc -w`
516 echo "# todo/fixme:" `echo $todos | wc -w`
517 echo "# of sav that remains:" `echo $remains | wc -w`
518 exit
519 fi
520
521 echo "engine: $engine ($enginebinname $OPT)"
522 echo "ok: " `echo $ok | wc -w` "/" `echo $ok $nok $nos $todos | wc -w`
523
524 if [ -n "$nok" ]; then
525 echo "fail: $nok"
526 echo "There were $(echo $nok | wc -w) errors ! (see file $ERRLIST)"
527 fi
528 if [ -n "$nos" ]; then
529 echo "no sav: $nos"
530 fi
531 if [ -n "$todos" ]; then
532 echo "todo/fixme: $todos"
533 fi
534 if [ -n "$remains" ]; then
535 echo "sav that remains: $remains"
536 fi
537
538 # write $ERRLIST
539 if [ "x$ERRLIST" != "x" ]; then
540 if [ -x "$ERRLIST_TARGET" ]; then
541 mv "$ERRLIST_TARGET" "${ERRLIST_TARGET}.bak"
542 fi
543 mv $ERRLIST $ERRLIST_TARGET
544 fi
545
546 echo >>$xml "</testsuite></testsuites>"
547
548 if [ -n "$nok" ]; then
549 exit 1
550 else
551 exit 0
552 fi